const gulp = require('gulp');
const uglify = require('gulp-uglify');
const rename = require("gulp-rename");
const sourcemaps = require('gulp-sourcemaps');
const sass = require('gulp-sass')(require('sass'));
const filenameJs = "fileinput.js";
const filenameCss = "fileinput.scss"

gulp.task('js-compress', function() {
    return gulp.src(`./js/${filenameJs}`)
        .pipe(sourcemaps.init()) // init sourcemaps
        .pipe(uglify())
        .pipe(rename(function(path) {
            path.basename += ".min";
            path.extname = ".js";
        }))
        .pipe(sourcemaps.write('./'))
        .pipe(gulp.dest('./dist/js'));
});

gulp.task('js-original', function() {
    return gulp.src(`./js/${filenameJs}`)
        .pipe(gulp.dest('./dist/js'));
});

gulp.task('css-compress', function () {
    return gulp.src(`./scss/${filenameCss}`)
        .pipe(sass().on('error', sass.logError))
        .pipe(gulp.dest('./dist/css'))
        .pipe(sourcemaps.init())
        .pipe(sass({outputStyle: 'compressed'}).on('error', sass.logError))
        .pipe(rename(function(path) {
            path.basename += ".min";
            path.extname = ".css";
        }))
        .pipe(sourcemaps.write('./'))
        .pipe(gulp.dest('./dist/css'));
});

gulp.task('js-build', gulp.parallel('js-compress', 'js-original'));
